      .586
      .model flat, stdcall     ; 32 bit memory model
      option casemap :none     ; Case sensitive

     include     OemPad.inc   ; local includes for this file

.code

start:
      INVOKE     GetModuleHandle, NULL
         mov     hInst, eax
      INVOKE     GetCommandLine
         mov     CommandLine, eax
      INVOKE     InitCommonControls

      INVOKE     WinMain, hInst,NULL,CommandLine,SW_SHOWDEFAULT
      INVOKE     ExitProcess,eax

;===================================
;* WinMain procedure
;===================================
WinMain proc hinst:DWORD, hPrevInst, CmdLine, CmdShow

LOCAL     wc:WNDCLASSEX
LOCAL     msg:MSG
LOCAL     Wwd:DWORD, Wht, Wtx, Wty

;---------- [Fill WNDCLASSEX structure with required variables] ----------
      INVOKE     LoadIcon, hInst, 500    ; icon ID
         mov     hIcon, eax

         mov     wc.cbSize, sizeof WNDCLASSEX
         mov     wc.style, CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
         mov     wc.lpfnWndProc, offset WndProc
         mov     wc.cbClsExtra, NULL
         mov     wc.cbWndExtra, NULL
       MOVmd     wc.hInstance, hInst
      INVOKE     GetStockObject, HOLLOW_BRUSH
         mov     wc.hbrBackground, eax
         mov     wc.lpszMenuName, NULL
         mov     wc.lpszClassName, offset szClassName
       MOVmd     wc.hIcon, hIcon
      INVOKE     LoadCursor, NULL, IDC_ARROW
         mov     wc.hCursor, eax
       MOVmd     wc.hIconSm, 0 ;hIcon
      INVOKE     RegisterClassEx, addr wc

;---------- [Center window at the following size] ----------
         mov     Wwd, 500
         mov     Wht, 350
      INVOKE     GetSystemMetrics, SM_CXSCREEN
         sub     eax, Wwd
         shr     eax, 1
         mov     Wtx, eax
      INVOKE     GetSystemMetrics, SM_CYSCREEN
         sub     eax, Wht
         shr     eax,1
         mov     Wty, eax

      INVOKE     CreateWindowEx, WS_EX_LEFT,addr szClassName, addr szUntitled,
                 WS_OVERLAPPEDWINDOW, Wtx, Wty, Wwd, Wht, 0, 0, hInst, 0
         mov     hWnd, eax

      INVOKE     LoadMenu, hInst, 600  ; menu ID
      INVOKE     SetMenu, hWnd, eax

      INVOKE     ShowWindow, hWnd, SW_SHOWNORMAL
      INVOKE     UpdateWindow, hWnd

;---------- [Loop until PostQuitMessage is sent] ----------
      .while TRUE
         INVOKE     GetMessage, addr msg, 0, 0, 0
         .break .if (!eax)
         INVOKE     TranslateMessage, addr msg
         INVOKE     DispatchMessage, addr msg
      .endw
         mov     eax, msg.wParam

         ret
WinMain endp

;===================================
;* WndProc procedure
;===================================
WndProc proc  uses ebx edx  hwnd:DWORD, uMsg, wParam, lParam

LOCAL     tbh:DWORD, sbh
LOCAL     rect   :RECT


      .if uMsg == WM_CREATE

;---------- [Create the status bar window] ----------
CreateTool:
         INVOKE     CreateStatusWindow, WS_CHILD or WS_VISIBLE or \
                    SBS_SIZEGRIP, 0, hwnd, 200
            mov     hwndStat, eax
            mov     [sbParts+0], 200    ; pixels from left
            mov     [sbParts+4], 300    ; pixels from left
            mov     [sbParts+8], 400    ; pixels from left
            mov     [sbParts+12], -1    ; last part
         INVOKE     SendMessage, hwndStat, SB_SETPARTS, 4, addr sbParts

;---------- [Create the tool bar window] ----------
         INVOKE     CreateWindowEx, 0, addr tbClass,
                    addr szDisplayName, WS_CHILD or WS_VISIBLE,
                    0, 0, 1000, 40, hwnd, 0, hInst, 0
            mov     hwndTool, eax

         INVOKE     LoadBitmap, hInst, 750
            mov     hTbBmp, eax

         INVOKE     SendMessage, hwndTool, TB_BUTTONSTRUCTSIZE, sizeof TBBUTTON, 0
            mov     ecx, 16  ; loword = bitmap Width
            mov     eax, 16  ; hiword = bitmap Height
            shl     eax, 16
            mov     ax, cx
            mov     bSize, eax
         INVOKE     SendMessage, hwndTool, TB_SETBITMAPSIZE, 0, bSize

            mov     tbab.hInst, 0
          MOVmd     tbab.nID, hTbBmp
         INVOKE     SendMessage, hwndTool, TB_ADDBITMAP, 9, addr tbab
         INVOKE     SendMessage, hwndTool, TB_SETBUTTONSIZE, 0, bSize

          TBSep     hwndTool
         TBButt     hwndTool, 0,  1000, 0
         TBButt     hwndTool, 1,  1001, 0
         TBButt     hwndTool, 2,  1002, 0
          TBSep     hwndTool
         TBButt     hwndTool, 3,  1100, 0
         TBButt     hwndTool, 4,  1101, 0
         TBButt     hwndTool, 5,  1102, 0
         TBButt     hwndTool, 6,  1103, 0
         TBButt     hwndTool, 7,  1104, 0
          TBSep     hwndTool
         TBButt     hwndTool, 21, 1010, 0

            mov     WrapFlag, 0

;---------- [Create the Edit window] ----------
         INVOKE     CreateWin, NULL, 0, 30, 300, 200, hwnd, 700, WrapFlag

         INVOKE     SendMessage, hwndStat, SB_SETTEXT, 1, addr WrapOFF

      .elseif uMsg == WM_SIZE
         INVOKE     SendMessage, hwndTool, TB_AUTOSIZE, 0, 0
         INVOKE     MoveWindow, hwndStat, 0, 0, 0, 0, TRUE

         INVOKE     GetClientRect, hwndTool, addr rect
          MOVmd     tbh, rect.bottom
         INVOKE     GetClientRect, hwndStat, addr rect
          MOVmd     sbh, rect.bottom

         INVOKE     GetClientRect, hwnd, addr rect
            mov     ebx, rect.right
            mov     ecx, rect.bottom

            mov     eax, tbh
            sub     ecx, eax
            mov     eax, sbh
            sub     ecx, eax
            add     tbh, 2
            sub     ecx, 2
         INVOKE     MoveWindow, hEdit, 0, tbh, ebx, ecx, TRUE

      .elseif uMsg == WM_COMMAND
;---------- [Menu and Toolbar commands] ----------

         .if wParam == 1000      ; NewFile
            INVOKE     SendMessage, hEdit, EM_GETMODIFY, 0, 0
            .if eax == TRUE
               INVOKE     Confirmation, hwnd
                  .if eax == IDYES
                       call     SaveFile
                  .elseif eax == IDCANCEL
                        mov     eax, 0
                        ret
                  .endif
            .endif

            INVOKE     SetWindowText, hEdit, NULL
            INVOKE     SetWindowText, hwnd, addr szUntitled
            INVOKE     SendMessage, hwndStat, SB_SETTEXT, 0, NULL

         .elseif wParam == 1001  ; OpenFile
              call     OpenFileA

         .elseif wParam == 1002  ; SaveFile 
              call     SaveFile

         .elseif wParam == 1003  ; SaveAs
              call     SaveFileAs
         .endif

         .if wParam == 1010
            INVOKE     SendMessage, hwnd, WM_SYSCOMMAND, SC_CLOSE, NULL
         .elseif wParam == 1900
            INVOKE     ShellAbout, hWnd, addr szDisplayName, addr AboutMsg, hIcon
         .endif

         .if wParam == 1100      ; Cut
            INVOKE     SendMessage, hEdit, WM_CUT, 0, 0

         .elseif wParam == 1101  ; Copy
            INVOKE     SendMessage, hEdit, WM_COPY, 0, 0

         .elseif wParam == 1102  ; Paste
            INVOKE     SendMessage, hEdit, WM_PASTE, 0, 0

         .elseif wParam == 1103  ; Clear
            INVOKE     SendMessage, hEdit, WM_CLEAR, 0, 0

         .elseif wParam == 1104  ; Undo
            INVOKE     SendMessage, hEdit, WM_UNDO, 0, 0

         .elseif wParam == 1105  ; WordWrap
              call     WordWrap

         .elseif wParam == 1206  ; Change Font Size
            INVOKE     CreateOEMFont, 6
         .elseif wParam == 1209  ; Change Font Size
            INVOKE     CreateOEMFont, 9
         .elseif wParam == 1212  ; Change Font Size
            INVOKE     CreateOEMFont, 12

         .endif
;---------- [End Menu and Toolbar commands] ----------

      .elseif uMsg == WM_SETFOCUS
         INVOKE     SetFocus, hEdit

      .elseif uMsg == WM_SYSCOLORCHANGE
         INVOKE     DestroyWindow, hwndTool
            jmp     CreateTool

      .elseif uMsg == WM_CLOSE
         INVOKE     SendMessage, hEdit, EM_GETMODIFY, 0, 0
         .if eax == TRUE
            INVOKE     Confirmation, hwnd
            .if eax == IDYES
                 call     SaveFile
            .elseif eax == IDCANCEL
                  mov     eax, 0
                  ret
            .endif
         .endif

      .elseif uMsg == WM_DESTROY
         INVOKE     PostQuitMessage, NULL
            xor     eax, eax
            ret
      .endif

      INVOKE     DefWindowProc, hwnd, uMsg, wParam, lParam

         ret

WndProc endp

;======================================
;* CreateWin procedure
;======================================
CreateWin proc szMsg:DWORD, tx, ty, wd, ht, hwnd, ID, Wrap
LOCAL    Style:DWORD

         mov     Style, WS_VISIBLE or WS_CHILDWINDOW or \
                 WS_VSCROLL or ES_NOHIDESEL or \
                 ES_AUTOVSCROLL or ES_MULTILINE

      .if Wrap == 0
             or     Style, WS_HSCROLL or ES_AUTOHSCROLL
      .endif

;      INVOKE     LoadLibrary,ADDR ReDLL
;      INVOKE     CreateWindowEx, WS_EX_CLIENTEDGE, addr EditRT, szMsg,

      INVOKE     CreateWindowEx, WS_EX_CLIENTEDGE, addr EditClass, szMsg,
                 Style, tx, ty, wd, ht, hwnd, ID, hInst, NULL
         mov     hEdit, eax

      INVOKE     SetWindowLong, hEdit, GWL_WNDPROC, EditProc
         mov     lpEditProc, eax
      .if !FontSize
            mov     FontSize, 9
      .endif
      INVOKE     CreateOEMFont, FontSize

         ret
CreateWin endp

;======================================
;* Create font procedure
;======================================
CreateOEMFont proc SizeF:DWORD
LOCAL    lf:LOGFONT

       MOVmd     FontSize, SizeF
       MOVmd     lf.lfHeight, SizeF  ; 6 9 12

;        push     SizeF
;         pop     lf.lfHeight  ;5 6 9 12 14
         mov     lf.lfWidth, 0
         mov     lf.lfEscapement, 0
         mov     lf.lfOrientation, 0
         mov     lf.lfWeight, 500
         mov     lf.lfItalic, 0
         mov     lf.lfUnderline, 0
         mov     lf.lfStrikeOut, 0 
         mov     lf.lfCharSet, OEM_CHARSET
         mov     lf.lfOutPrecision, OUT_DEFAULT_PRECIS
         mov     lf.lfClipPrecision, CLIP_DEFAULT_PRECIS 
         mov     lf.lfQuality, DEFAULT_QUALITY
         mov     lf.lfPitchAndFamily, FIXED_PITCH or FF_DONTCARE
      INVOKE     lstrcpy, addr lf.lfFaceName, addr FontName
      INVOKE     CreateFontIndirect, addr lf
         mov     hFont, eax

      INVOKE     SendMessage, hEdit, WM_SETFONT, hFont, TRUE

         ret
CreateOEMFont endp

;======================================
;* Open file procedure
;======================================
OpenFileA proc

      INVOKE     SendMessage, hEdit, EM_GETMODIFY ,0, 0
      .if eax == TRUE
         INVOKE     Confirmation, hWnd
         .if eax == IDYES
              call     SaveFile
         .elseif eax == IDCANCEL
               mov     eax, 0
               ret
         .endif
      .endif

         mov     byte ptr szFileName, 0
         mov     ofn.lStructSize, sizeof OPENFILENAME
       MOVmd     ofn.hwndOwner, hWnd
       MOVmd     ofn.hInstance, hInst
         mov     ofn.lpstrFilter, offset szFilterO
         mov     ofn.lpstrFile, offset szFileName
         mov     ofn.nMaxFile, sizeof szFileName
         mov     ofn.lpstrTitle, offset szTitleO
         mov     ofn.Flags, OFN_EXPLORER or OFN_FILEMUSTEXIST or OFN_LONGNAMES
      INVOKE     GetOpenFileName, addr ofn
         cmp     eax, FALSE       ;Cancel'ed or error occurred
          je     NoFile
      INVOKE     ReadEM, addr szFileName, hEdit
      INVOKE     SetWindowText, hWnd, addr szFileName

NoFile:
         ret

OpenFileA endp

;======================================
;* Save file procedure
;======================================
SaveFile proc
LOCAL     buffer[256]:BYTE

;---------- [Test if title is 'Untitled'] ----------
      INVOKE     GetWindowText, hWnd, addr buffer, 250
      INVOKE     lstrcmp, addr buffer, addr szUntitled
      .if eax == 0
           call     SaveFileAs
            ret
      .endif
      INVOKE     WriteEM ,addr buffer

         ret

SaveFile endp

;======================================
;* Save file as procedure
;======================================
SaveFileAs proc

         mov     ofn.lStructSize, sizeof OPENFILENAME
       MOVmd     ofn.hwndOwner, hWnd
       MOVmd     ofn.hInstance, hInst
         mov     ofn.lpstrFilter, offset szFilterS
         mov     ofn.lpstrFile, offset szFileName
         mov     ofn.nMaxFile, sizeof szFileName
         mov     ofn.lpstrTitle, offset szTitleS
         mov     ofn.Flags, OFN_EXPLORER or OFN_LONGNAMES
      INVOKE     GetSaveFileName, addr ofn
         cmp     eax, FALSE       ;Cancel'ed or error occurred
          je     NoFile
      INVOKE     WriteEM,addr szFileName
      INVOKE     SetWindowText,hWnd,addr szFileName

NoFile:
         ret

SaveFileAs endp

;======================================
;* Read file procedure
;======================================
ReadEM proc lpszDiskFile:DWORD, hEditControl:DWORD

LOCAL     hFile:DWORD, bytesread, hMem, pMem
LOCAL     txtBuffer[64]:BYTE, szWork[10] 

      INVOKE     CreateFile, lpszDiskFile,\
                 GENERIC_READ or GENERIC_WRITE,\
                 FILE_SHARE_READ or FILE_SHARE_WRITE,\
                 0, OPEN_EXISTING, FILE_ATTRIBUTE_ARCHIVE, 0
         mov     hFile, eax

      INVOKE     GetFileSize, hFile, NULL
      .if eax > 32767  ;????????????????????????????????????????????????
         INVOKE     CloseHandle, hFile
         INVOKE     MessageBox, hWnd, addr TooBig, addr szDisplayName, MB_OK
            xor     eax, eax
            ret
      .endif

      INVOKE     GlobalAlloc, GMEM_MOVEABLE or GMEM_ZEROINIT, MemSize   ;MemSize ;32767
         mov     hMem, eax
      INVOKE     GlobalLock, hMem
         mov     pMem, eax
      INVOKE     ReadFile, hFile, pMem, MemSize-1, addr bytesread, NULL ;MemSize-1 ;32766
      INVOKE     SendMessage, hEditControl, WM_SETTEXT, NULL, pMem
      INVOKE     CloseHandle, hFile
      INVOKE     GlobalUnlock, pMem
      INVOKE     GlobalFree, hMem
      INVOKE     BaseAscii, bytesread, addr szWork, 0
      INVOKE     lstrcpy, addr txtBuffer, addr szOpenedAt
      INVOKE     lstrcat, addr txtBuffer, addr szWork
      INVOKE     lstrcat, addr txtBuffer, addr bytes
      INVOKE     SendMessage, hwndStat, SB_SETTEXT, 0, addr txtBuffer

         ret
ReadEM endp

;======================================
;* Confirmation procedure
;======================================
Confirmation proc hwnd:DWORD

      INVOKE     MessageBox, hwnd, addr ConfirmMsg, addr szDisplayName,
                 MB_YESNOCANCEL or MB_ICONQUESTION
         ret
Confirmation endp

;======================================
;* Write file procedure
;======================================
WriteEM proc lpszFile_Name:DWORD

LOCAL     hFile:DWORD, bytesread, hMem, pMem
LOCAL txtBuffer[64], szWork[10]


      INVOKE     CreateFile, lpszFile_Name,\
                 GENERIC_READ or GENERIC_WRITE,\
                 FILE_SHARE_READ or FILE_SHARE_WRITE,\
                 0, CREATE_ALWAYS,FILE_ATTRIBUTE_ARCHIVE, 0
         mov     hFile, eax

      INVOKE     GlobalAlloc, GMEM_MOVEABLE or GMEM_ZEROINIT, MemSize
         mov     hMem, eax
      INVOKE     GlobalLock, hMem
         mov     pMem, eax
      INVOKE     SendMessage, hEdit,WM_GETTEXT, MemSize-1, pMem
      INVOKE     lstrlen, pMem
         mov     ecx, eax
      INVOKE     WriteFile, hFile, pMem, ecx, ADDR bytesread, NULL
      INVOKE     CloseHandle, hFile
      INVOKE     GlobalUnlock, pMem
      INVOKE     GlobalFree, hMem
      INVOKE     BaseAscii, bytesread, addr szWork, 0
      INVOKE     lstrcpy, addr txtBuffer, addr szSavedAt
      INVOKE     lstrcat, addr txtBuffer, addr szWork
      INVOKE     lstrcat, addr txtBuffer, addr bytes
      INVOKE     SendMessage, hwndStat, SB_SETTEXT, 0, addr txtBuffer
      INVOKE     SendMessage, hEdit, EM_SETMODIFY, FALSE, 0

         ret

WriteEM endp


;======================================
;* Word wrap procedure
;======================================
WordWrap proc

LOCAL     mFlag:DWORD, Len, hMem, pMem

      INVOKE     SendMessage,hEdit,EM_GETMODIFY,0,0
         mov     mFlag, eax

      INVOKE     GetWindowTextLength, hEdit
         mov     Len, eax
         inc     Len

      INVOKE     GlobalAlloc, GMEM_MOVEABLE or GMEM_ZEROINIT, Len
         mov     hMem, eax
      INVOKE     GlobalLock, hMem
         mov     pMem, eax

      INVOKE     GetWindowText, hEdit, pMem, Len
      INVOKE     DestroyWindow, hEdit

      .if WrapFlag == 0
            mov     WrapFlag, 1
         INVOKE     SendMessage, hwndStat, SB_SETTEXT, 1, addr WrapON
      .elseif WrapFlag == 1
            mov     WrapFlag, 0
         INVOKE     SendMessage, hwndStat, SB_SETTEXT, 1, addr WrapOFF
      .endif

      INVOKE     CreateWin, NULL, 0, 30, 300, 200, hWnd, 700, WrapFlag

      INVOKE     SendMessage, hWnd, WM_SIZE, 0, 0

      INVOKE     SetWindowText, hEdit, pMem
      INVOKE     GlobalUnlock, pMem
      INVOKE     GlobalFree, hMem
      INVOKE     SendMessage, hEdit, EM_SETMODIFY, mFlag, 0
      INVOKE     SetFocus, hEdit

    ret

WordWrap endp

;======================================
;* Edit subclass procedure
;======================================
EditProc proc hCtl:DWORD, uMsg, wParam, lParam

      .if uMsg == WM_KEYUP
         .if wParam == VK_F1
            INVOKE     ShellAbout, hWnd, addr szDisplayName, addr AboutMsg, hIcon
         .elseif wParam == VK_F9
              call     WordWrap
         .elseif wParam == VK_ESCAPE
            INVOKE     SendMessage, hWnd, WM_SYSCOMMAND, SC_CLOSE, NULL
               xor     eax, eax
               ret
         .endif
      .endif

      INVOKE     CallWindowProc, lpEditProc, hCtl, uMsg, wParam, lParam
         ret

EditProc endp

;=========================================================================
;  Converts a 32 bit num value to a  ascii string.
;=========================================================================
BaseAscii proc uses edx esi edi InPut:DWORD, OutPut, Fill

         mov     eax, InPut
         mov     edi, OutPut
      .if eax < 10 && Fill
            mov     byte ptr [edi], '0'
            inc     edi
      .endif
         mov     esi, edi
         mov     ecx, 10
      .while (eax > 0)
            xor     edx, edx
            div     ecx              ; Put next digit in edx
            add     dl, '0'          ; Convert to ASCII
            mov     [edi], dl        ; Store it
            inc     edi
      .endw
         mov     byte ptr [edi], 0   ; Terminate the string
      .while (esi < edi)
            dec     edi
            mov     al, [esi]
            mov     ah, [edi]
            mov     [edi], al
            mov     [esi], ah
            inc     esi
      .endw
         ret

BaseAscii endp

end start
